/* The following two libraries are included with the Arduino IDE  */
#include <Robot3DoTBoard.h>     // instantiated as Robot3DoT at end of class header
#include <SPI.h>       // supports SPI serial communication and defines analog pins
#include <EEPROM.h>
#include <Wire.h>      // I2C support (currently not implemented)
#include <Adafruit_Sensor.h>
#include "Adafruit_SI1145.h"
#define FALSE 0        // LOW
#define TRUE  1        // HIGH
Robot3DoTBoard Robot3DoT;       // instantiated as Robot3DoT at end of class header
/**************** Robot Configuration **************
   Set Rover, Pinouts, Connection Type, and Pinger
 ***************************************************/
#include "pinouts_robot.h"    // replace with your pinout
//--------------------------------START CUSTOM COMMAND IDs
#define BLINK  0x46//using THIS BECAUSE I HAD MORE CAN USE 0X40-0X5F
#define DETECT 0x40// you dont need TO DEFINE MOVE BECAUSE ITS DEFINED ON CONFIGURE.H
void moveHandler (uint8_t cmd, uint8_t param[], uint8_t n);
void blinkHandler (uint8_t cmd, uint8_t param[], uint8_t n);
void detectHandler (uint8_t cmd, uint8_t param[], uint8_t n);

const uint8_t CMD_LIST_SIZE = 3;   // we are adding 3 commands (MOVE, BLINK, Detect)
//-------------------------------END COMMAND ID
Robot3DoTBoard::cmdFunc_t onCommand[CMD_LIST_SIZE] = {{MOVE, moveHandler}, {BLINK, blinkHandler}, {DETECT, detectHandler}};
//-------------------------------END DECLARE COMMANDS
#define PaperBot TRUE
#define bluetooth TRUE       // Leonardo class rovers - Serial used for USB, Serial1 for bluetooth (i.e., USART)
#define pinger FALSE          // FALSE if no ultrasonic sensor is used.
#define debug  FALSE

// note: #define is a text substitution pre-processor directive
#define Limit 320// IR SEEING

//---------Pro Micro
//const int pingPin = 16;//FOR PING SIGNAL
//START EYE LEDS
/**************** Global Variables ****************
   source: Found in CommunicationRobotPilot Folder
 ***************************************************/
const int16_t FLAG = -128;  // value returned by readFuelGauge when called
// by sendDataon undervoltage condition
// Timer Variable
unsigned long timer;        // unsigned 32-bit

boolean collisionDetection = FALSE;

void setup() {
  pinMode(14, OUTPUT);  //JUST SETTING THINGS UP
  pinMode(15, OUTPUT);
  //  Serial.begin(9600);      // legacy rovers operated at 57600
#if bluetooth
  Serial1.begin(9600);
  while (!Serial) {

  }
#endif
  Robot3DoT.begin();
  Robot3DoT.setOnCommand(onCommand, CMD_LIST_SIZE);//telling processor about new commands
  /*
    while (!Serial) {
    ; // wait for USB serial port to connect. Needed for Leonardo only
    }
  */
  //---------------------------------------START SELECTING I2C PORTS
  tcaselect(2);//PORT 2 - LEFT SENSOR
  if (! uv1.begin()) {
    Serial.println("Didn't find Left Sensor");
  }
  tcaselect(5);//PORT 5 -CENTER SENSOR
  if (!uv2.begin()) {
    Serial.println("Didn't find SENSOR 1");
  }
  tcaselect(7);//PORT 7 - RIGHT SENSOR
  if (!uv3.begin()) {
    Serial.println("Didn't find SENSOR 2");
  }
  //------------------------------------------End Selecting I2C Ports
  delay(100);
  timer = millis();        // telemetry
  // init_servos();        // Rosco uses servos

  //  pinMode(led, OUTPUT);    // initialize LED indicator as an output.

  // Configure motorshield and insure motors are off.
  // If included in design, turn off collisionDetection
  setup_TB6612FNG();    // sparkfun_TB6612FNG
}

void loop() {
  Robot3DoT.loop();
#if bluetooth
  if (Serial1.available() ) commandDecoder(); // note: Leonardo does not support serialEvent() handler
#else
  if (Serial.available() ) commandDecoder();
#endif

  // future: replace with watchdog timer interrupt  ****

  if (millis() > getNextPing()) {
    sendWordPacket(EMERGENCY_ID, WATCHDOG_TIMEOUT);

#if bluetooth                                // if packet sent over USART=>bluetooth,  
    Serial.print("Emergency exception 0x0");   // send duplicate data as text to
    Serial.println(WATCHDOG_TIMEOUT, HEX);     // USB=>Arduino IDE Serial Monitor.
#endif

    // ****** SLEEP PAPERBOT *******

    // ##### JEFF CHANGED
    // Until the above-mentioned "SLEEP PAPERBOT" is implemented,
    // let's reset to allow another ping interval to avoid the
    // constant barrage of an exception message on every loop.
    updateNextPing();
    // #####
  }


  sendData(); // Call to send Data for Control Panel Feedback

  // If using a Pinger detect a collision
#if pinger == TRUE
  if (collisionDetection) {
    if (checkSonar()) {
      // insure motors are off and turn off collisionDetection
      stopMotors();
      collisionDetection = FALSE;   // rover is not moving
      // send Emergency Stop message
    }
  }
#endif
  //-----------------------------------------START automatic walking


}  // end of loop

